#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;



namespace FilterTemplate {

	/// <summary>
	/// Summary for SettingsForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class SettingsForm : public System::Windows::Forms::Form
	{
	public:
		filtersettings* FilterSetting;
		bool FilterCancelled;
		Bitmap^ PreviewBitmap;
		Rectangle SourceRect, DestinationRect;
		int SWidth, SHeight;
		int LastX, LastY;
		bool MouseButtonDown;

	private: 
		System::Windows::Forms::HScrollBar^		HueScrollBar;
		System::Windows::Forms::HScrollBar^		SaturationScrollBar;
		System::Windows::Forms::HScrollBar^		ValueScrollBar;
		System::Windows::Forms::Label^			label1;
		System::Windows::Forms::Label^			label2;
		System::Windows::Forms::Label^			HueLabel;
		System::Windows::Forms::Label^			SaturationLabel;
		System::Windows::Forms::Label^			ValueLabel;
		System::Windows::Forms::Label^			label3;
		System::Windows::Forms::Button^			ButtonApply;
		System::Windows::Forms::Button^			ButtonCancel;
		System::Windows::Forms::PictureBox^		Preview;
		System::ComponentModel::IContainer^		components;

	public:
		SettingsForm(filtersettings* fs)
		{
			InitializeComponent();

			FilterSetting = fs;

			HueScrollBar->Minimum = 0;
			HueScrollBar->Maximum = 360;
			SaturationScrollBar->Minimum = 0;
			SaturationScrollBar->Maximum = 1000;
			ValueScrollBar->Minimum = 0;
			ValueScrollBar->Maximum = 1000;

			HueScrollBar->Value = fs->hue;
			SaturationScrollBar->Value = fs->sat;
			ValueScrollBar->Value = fs->val;

			SWidth = fs->width;
			SHeight = fs->height;

			FilterCancelled = true;
			PreviewBitmap = gcnew Bitmap(Preview->ClientSize.Width, Preview->ClientSize.Height);

			DestinationRect.X = (SWidth < Preview->ClientSize.Width) ? ((Preview->ClientSize.Width - SWidth) / 2) : 0;
			DestinationRect.Y = (SHeight < Preview->ClientSize.Height) ? ((Preview->ClientSize.Height - SHeight) / 2) : 0;
			DestinationRect.Width = (DestinationRect.X) ? SWidth : Preview->ClientSize.Width;
			DestinationRect.Height = (DestinationRect.Y) ? SHeight : Preview->ClientSize.Height;

			SourceRect.X = 0;
			SourceRect.Y = 0;
			SourceRect.Width = DestinationRect.Width;   // SHOULD BE EQUAL !!!
			SourceRect.Height = DestinationRect.Height; // SHOULD BE EQUAL !!!

			MouseButtonDown = false;

			Scroll_Change(nullptr, nullptr);
		}

	protected:

		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			this->Preview = (gcnew System::Windows::Forms::PictureBox());
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->HueScrollBar = (gcnew System::Windows::Forms::HScrollBar());
			this->SaturationScrollBar = (gcnew System::Windows::Forms::HScrollBar());
			this->ValueScrollBar = (gcnew System::Windows::Forms::HScrollBar());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->HueLabel = (gcnew System::Windows::Forms::Label());
			this->SaturationLabel = (gcnew System::Windows::Forms::Label());
			this->ValueLabel = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Preview))->BeginInit();
			this->SuspendLayout();
			// 
			// Preview
			// 
			this->Preview->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->Preview->Cursor = System::Windows::Forms::Cursors::NoMove2D;
			this->Preview->Location = System::Drawing::Point(12, 12);
			this->Preview->Name = L"Preview";
			this->Preview->Size = System::Drawing::Size(154, 154);
			this->Preview->TabIndex = 0;
			this->Preview->TabStop = false;
			this->Preview->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseDown);
			this->Preview->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseMove);
			this->Preview->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &SettingsForm::Preview_OnPaint);
			this->Preview->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseUp);
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(183, 143);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(264, 143);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// HueScrollBar
			// 
			this->HueScrollBar->LargeChange = 1;
			this->HueScrollBar->Location = System::Drawing::Point(183, 26);
			this->HueScrollBar->Maximum = 360;
			this->HueScrollBar->Name = L"HueScrollBar";
			this->HueScrollBar->Size = System::Drawing::Size(250, 17);
			this->HueScrollBar->TabIndex = 7;
			this->HueScrollBar->Value = 180;
			this->HueScrollBar->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// SaturationScrollBar
			// 
			this->SaturationScrollBar->LargeChange = 1;
			this->SaturationScrollBar->Location = System::Drawing::Point(183, 67);
			this->SaturationScrollBar->Maximum = 1000;
			this->SaturationScrollBar->Name = L"SaturationScrollBar";
			this->SaturationScrollBar->Size = System::Drawing::Size(250, 17);
			this->SaturationScrollBar->TabIndex = 8;
			this->SaturationScrollBar->Value = 500;
			this->SaturationScrollBar->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// ValueScrollBar
			// 
			this->ValueScrollBar->LargeChange = 1;
			this->ValueScrollBar->Location = System::Drawing::Point(183, 107);
			this->ValueScrollBar->Maximum = 1000;
			this->ValueScrollBar->Name = L"ValueScrollBar";
			this->ValueScrollBar->Size = System::Drawing::Size(250, 17);
			this->ValueScrollBar->TabIndex = 9;
			this->ValueScrollBar->Value = 500;
			this->ValueScrollBar->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->ForeColor = System::Drawing::Color::White;
			this->label1->Location = System::Drawing::Point(180, 12);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(27, 13);
			this->label1->TabIndex = 10;
			this->label1->Text = L"Hue";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->ForeColor = System::Drawing::Color::White;
			this->label2->Location = System::Drawing::Point(180, 52);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(55, 13);
			this->label2->TabIndex = 11;
			this->label2->Text = L"Saturation";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->ForeColor = System::Drawing::Color::White;
			this->label3->Location = System::Drawing::Point(180, 92);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(34, 13);
			this->label3->TabIndex = 12;
			this->label3->Text = L"Value";
			// 
			// HueLabel
			// 
			this->HueLabel->AutoSize = true;
			this->HueLabel->ForeColor = System::Drawing::Color::White;
			this->HueLabel->Location = System::Drawing::Point(436, 30);
			this->HueLabel->Name = L"HueLabel";
			this->HueLabel->Size = System::Drawing::Size(21, 13);
			this->HueLabel->TabIndex = 13;
			this->HueLabel->Text = L"0%";
			// 
			// SaturationLabel
			// 
			this->SaturationLabel->AutoSize = true;
			this->SaturationLabel->ForeColor = System::Drawing::Color::White;
			this->SaturationLabel->Location = System::Drawing::Point(436, 71);
			this->SaturationLabel->Name = L"SaturationLabel";
			this->SaturationLabel->Size = System::Drawing::Size(21, 13);
			this->SaturationLabel->TabIndex = 14;
			this->SaturationLabel->Text = L"0%";
			// 
			// ValueLabel
			// 
			this->ValueLabel->AutoSize = true;
			this->ValueLabel->ForeColor = System::Drawing::Color::White;
			this->ValueLabel->Location = System::Drawing::Point(436, 111);
			this->ValueLabel->Name = L"ValueLabel";
			this->ValueLabel->Size = System::Drawing::Size(21, 13);
			this->ValueLabel->TabIndex = 15;
			this->ValueLabel->Text = L"0%";
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::SteelBlue;
			this->ClientSize = System::Drawing::Size(552, 178);
			this->Controls->Add(this->ValueLabel);
			this->Controls->Add(this->SaturationLabel);
			this->Controls->Add(this->HueLabel);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->ValueScrollBar);
			this->Controls->Add(this->SaturationScrollBar);
			this->Controls->Add(this->HueScrollBar);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->Controls->Add(this->Preview);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->Text = L"Hue / Saturation / Value - Adjust";
			this->Load += gcnew System::EventHandler(this, &SettingsForm::SettingsForm_Load);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Preview))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	public:
		void RefreshPreview(bool applyfilter)
		{
			BitmapData^ bd = PreviewBitmap->LockBits( Rectangle(0, 0, PreviewBitmap->Width, PreviewBitmap->Height), ImageLockMode::ReadWrite, PixelFormat::Format24bppRgb);

			FilterSetting->strideout = bd->Stride;
			FilterSetting->dataout = (Byte*)(void*)bd->Scan0;

			if (applyfilter)
				FilterSpace::ImageFilter::FilterCore(FilterSetting, SourceRect.X, SourceRect.Y, SourceRect.Width, SourceRect.Height);
			else
				FilterSpace::ImageFilter::ClipImage( FilterSetting, SourceRect.X, SourceRect.Y, SourceRect.Width, SourceRect.Height);

			PreviewBitmap->UnlockBits(bd);
			this->Refresh();
		}

	private: 
		System::Void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}

		System::Void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			this->Close();
		}

		System::Void Preview_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (e->Button == System::Windows::Forms::MouseButtons::Left) 
			{
				MouseButtonDown = true;
				LastX = e->X;
				LastY = e->Y;
				RefreshPreview(false);
			}
		}

		System::Void Preview_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (!MouseButtonDown) return;
			if (!DestinationRect.X)
			{
				SourceRect.X -= e->X - LastX;
				if (SourceRect.X < 0) SourceRect.X = 0;
				if (SourceRect.X >= SWidth - DestinationRect.Width) SourceRect.X = SWidth - DestinationRect.Width - 1;
			}
			if (!DestinationRect.Y)
			{
				SourceRect.Y -= e->Y - LastY;
				if (SourceRect.Y < 0) SourceRect.Y = 0;
				if (SourceRect.Y >= SHeight - DestinationRect.Height) SourceRect.Y = SHeight - DestinationRect.Height - 1;
			}
			RefreshPreview(false);
			LastX = e->X;
			LastY = e->Y;
		}

		System::Void Preview_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (e->Button == System::Windows::Forms::MouseButtons::Left) MouseButtonDown = false;
			if (!MouseButtonDown) RefreshPreview(true);
		}

		System::Void Preview_OnPaint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) 
		{
			Graphics^ g = e->Graphics;
			Rectangle r = Rectangle(0, 0, DestinationRect.Width, DestinationRect.Height);
			g->DrawImage(PreviewBitmap, DestinationRect, r, GraphicsUnit::Pixel);
		}


		System::Void SettingsForm_Load(System::Object^  sender, System::EventArgs^  e) 
		{
		}

		System::Void Scroll_Change(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			FilterSetting->hue = HueScrollBar->Value;
			FilterSetting->sat = SaturationScrollBar->Value;
			FilterSetting->val = ValueScrollBar->Value;

			HueLabel->Text = HueScrollBar->Value.ToString();
			SaturationLabel->Text = SaturationScrollBar->Value.ToString();
			ValueLabel->Text = ValueScrollBar->Value.ToString();

			RefreshPreview(true);
		}
};
}
